/*
ESUP-portail is a french academic project developed under the GPL (General Public License) augmented according to the following :
A binary or source file developped by ESUP-portail can be used or compiled with products under Apache license.
The official english text of the GPL can be found here : http://www.gnu.org/licenses/gpl.html .
A non official french translation can be found here : http://www.linux-France.org/article/these/gpl.html .
The different kinds of licenses governing the products developed by the Apache foundation can be found here : http://www.apache.org/licenses .
It follows that you can as well as use download contents as well modify and redistribute them provided you respect the GPL terms.
Downloading and using such contents do not provide any guaranty.
Be sure that you have well understood the terms of the license before using the contents it covers.
The ESUP-portail distribution includes the following distributions :
    * UPortal :
      software developed by JA-SIG (Java Architecture - Special Interest Group)
      You can find the license page here : http://mis105.udel.edu/ja-sig/uportal/license.html
    * CAS :
      SSO solution developed by Yale University
      You can find the project page here : http://www.yale.edu/tp/auth
    * Cocoon :
      XML framework distributed by the Apache foundation under Apache license;
      Please find the full text here : http://cocoon.apache.org/2.1/license.html
    * Mod_dav:
      A DAV module for Apache web server
      You can find the project page here : http://www.webdav.org/mod_dav
    * IMP :
      webmail from Horde application framework
      You can find the project page here : http://www.horde.org
    * . To be completed
*/

package org.esupportail.portal.channels.CPref.plugins;   

/** 
 * <p>Titre : CModifPerso</p>
 * <p>Description : Canal de modification des informations LDAP</p>
 * <p>Copyright : Copyright (c) 2004</p>
 * <p>Socit : esupPortail</p>
 * @author Sbatien GAUDIN
 * @version 1.0
 */

import org.esupportail.portal.utils.channels.Action;
import org.esupportail.portal.utils.channels.FrameWorkException;
import org.esupportail.portal.utils.channels.MainChannel;
import org.esupportail.portal.utils.channels.SubChannel;
import org.jasig.portal.ChannelRuntimeData;
import org.jasig.portal.PortalException;
import org.jasig.portal.services.LogService;

/**
 * @author sgaudin
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class AskPassword extends SubChannel  {

	static private String plugName = "plug.CModifInfo.AskPassword";

	/**
	 * Constructeur
	 * @param mainChannel
	 */
	public AskPassword(MainChannel mainChannel) {
		super(mainChannel);
	}
	
	/**
	 * Mthode statique qui permet d'enregistrer le plug-in Todo dans la liste des actions d'une channel
	 * 
	 * @param actions Liste des actions
	 */
	public static void register(MainChannel main) {
		Action action = new Action();		
		action.setName(plugName);
		action.setClassname(AskPassword.class.getName());
		action.setXslfile("AskPassword.xsl");
		action.setLogLevel(main.getConfigActions().getLogLevel());
		main.getConfigActions().getActions().put(action.getName(), action);
	}
	
	/**
	 * Mthode statique qui permet d'afficher la page du plug-in
	 * 
	 * @param main channel principale
	 * @param rd runtimeData
	 * @param newAction action sur laquelle aller lors du clic sur "OK"
	 * @throws PortalException
	 */
	public static void display(MainChannel main, ChannelRuntimeData rd, String newAction)throws PortalException{
		display(main,rd,newAction,false);
	}
	/**
	 * Mthode statique qui permet d'afficher la page du plug-in
	 * 
	 * @param main channel principale
	 * @param rd runtimeData
	 * @param newAction action sur laquelle aller lors du clic sur "OK"
	 * @throws PortalException
	 */
	public static void display(MainChannel main, ChannelRuntimeData rd, String newAction,boolean authFailed)throws PortalException{
		rd.setParameter("action",plugName);
		rd.setParameter("nextMode",newAction);
		if (authFailed)
			rd.setParameter("auth_failed","1");
		try {
			main.setRuntimeData(rd);
		} catch (PortalException e) {
			LogService.log(LogService.ERROR,"AskPassword:display() : PortalException : "+e);
			throw e;
		}
	}
	
	
	
	/* (non-Javadoc)
	 * @see org.esupportail.portal.utils.channels.ISubChannel#setXML()
	 */
	public Boolean setXML() throws FrameWorkException {
		if (runtimeData.getParameter("auth_failed")!=null)
			this.xslParameters.put("auth_failed","1");
		this.xslParameters.put("nextMode",getRuntimeData().getParameter("nextMode"));

		return Boolean.TRUE;
	}
}
